
#import <Foundation/Foundation.h>
#import <AppKit/AppKit.h>

#define NBCOUNT (8+8+4)

#define EX_COMPLETE @"SudokuCompleted"
#define EX_LOOP     @"SudokuLoop"

#define EX_COMPLETE_FMT @"Sudoku completed."
#define EX_LOOP_FMT     @"Solver entered a loop."

typedef enum {
    FIELD_VALUE = 0,
    FIELD_PUZZLE,
    FIELD_GUESS,
    FIELD_SCORE
} FIELD_TYPE;

typedef struct _field {
    int value, puzzle, guess;

    int x, y;

    void *nbdigits[9];
    int score;

    struct {
	int nx, ny;
    } adj[NBCOUNT];
} field, *fieldptr; 

#define FIELD_DIM 54
#define FONT_SIZE 36

#define SDK_DIM (9*FIELD_DIM)

@interface Sudoku : NSView
{
    field data[9][9];

    struct {
      int x, y;
    } seq[9*9];

    BOOL initial[9][9];

    BOOL success;
    int placed;

    int clues;
}

- initWithFrame:(NSRect)frame;

- (int)computescore:(fieldptr)fp;
- (BOOL)completed;

- (NSString *)stateToString:(FIELD_TYPE)what;
- stateFromLineEnumerator:(NSEnumerator *)en what:(FIELD_TYPE)what;

- (BOOL)initials;
- (BOOL)find:(unsigned long)seed;
- doFind:(NSMutableSet *)seen;

- (int)setClues:(int)count;
- (int)clues;

- reset;

- (void)drawString:(char *)str atX:(int)x andY:(int)y color:(NSColor *)col;
- (void)drawRect:(NSRect)rect;

- (void)mouseDown:(NSEvent *)theEvent;

- (unsigned int)draggingEntered:(id <NSDraggingInfo>)sender;
- (unsigned int)draggingUpdated:(id <NSDraggingInfo>)sender;

- (BOOL)performDragOperation:(id <NSDraggingInfo>)sender;
- (BOOL)prepareForDragOperation:(id <NSDraggingInfo>)sender;


@end
